//    ascii_painter is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    ascii_painter is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

//---------------------------------------------------------------------------------

// Author: Federico Salotti
// Organization\Company: Mr_Robot_Computers_Repair
// Country: Italy,Barga(LU)
// Release: V 1.0 (26 March 2019 23:55)




#include <SFML/Graphics.hpp>
#include <iostream>
#include <fstream>

std::string asciiConversion(int intensita)
{
	switch(intensita)
	{
	case 0:
 return "  ";
 break;
case 1:
 return ". ";
 break;
case 2:
 return "' ";
 break;
case 3:
 return "` ";
 break;
case 4:
 return "\\ ";
 break;
case 5:
 return "^ ";
 break;
case 6:
 return "\" ";
 break;
case 7:
 return ", ";
 break;
case 8:
 return ": ";
 break;
case 9:
 return "; ";
 break;
case 10:
 return "I ";
 break;
case 11:
 return "l ";
 break;
case 12:
 return "! ";
 break;
case 13:
 return "i ";
 break;
case 14:
 return "> ";
 break;
case 15:
 return "< ";
 break;
case 16:
 return "~ ";
 break;
case 17:
 return "+ ";
 break;
case 18:
 return "_ ";
 break;
case 19:
 return "- ";
 break;
case 20:
 return "? ";
 break;
case 21:
 return "] ";
 break;
case 22:
 return "[ ";
 break;
case 23:
 return "} ";
 break;
case 24:
 return "{ ";
 break;
case 25:
 return "1 ";
 break;
case 26:
 return ") ";
 break;
case 27:
 return "( ";
 break;
case 28:
 return "| ";
 break;
case 29:
 return "\\ ";
 break;
case 30:
 return "/ ";
 break;
case 31:
 return "t ";
 break;
case 32:
 return "f ";
 break;
case 33:
 return "j ";
 break;
case 34:
 return "r ";
 break;
case 35:
 return "x ";
 break;
case 36:
 return "n ";
 break;
case 37:
 return "u ";
 break;
case 38:
 return "v ";
 break;
case 39:
 return "c ";
 break;
case 40:
 return "z ";
 break;
case 41:
 return "X ";
 break;
case 42:
 return "Y ";
 break;
case 43:
 return "U ";
 break;
case 44:
 return "J ";
 break;
case 45:
 return "C ";
 break;
case 46:
 return "L ";
 break;
case 47:
 return "Q ";
 break;
case 48:
 return "0 ";
 break;
case 49:
 return "O ";
 break;
case 50:
 return "Z ";
 break;
case 51:
 return "m ";
 break;
case 52:
 return "w ";
 break;
case 53:
 return "q ";
 break;
case 54:
 return "p ";
 break;
case 55:
 return "d ";
 break;
case 56:
 return "b ";
 break;
case 57:
 return "k ";
 break;
case 58:
 return "h ";
 break;
case 59:
 return "a ";
 break;
case 60:
 return "o ";
 break;
case 61:
 return "* ";
 break;
case 62:
 return "# ";
 break;
case 63:
 return "M ";
 break;
case 64:
 return "W ";
 break;
case 65:
 return "& ";
 break;
case 66:
 return "8 ";
 break;
case 67:
 return "% ";
 break;
case 68:
 return "B ";
 break;
case 69:
 return "@ ";
 break;
case 70:
 return "$ ";
 break;
    }

	}

int main(int argc,char* argv[])
{

    // Load a sprite to display
    sf::Image image;
    image.loadFromFile(argv[1]);

    std::fstream writer;
    writer.open(argv[3],std::fstream::in | std::fstream::out | std::fstream::app);

    unsigned int imageWidth=image.getSize().x;
    unsigned int imageHeight=image.getSize().y;

    sf::Color pixelRGB;
    int scalaGrigi=0;
    int intensita=0;

    std::cout<<"Width: "<<imageWidth<<"\n";
    std::cout<<"Height: "<<imageHeight<<"\n";

    for(int y=0;y<=imageHeight;y++)
    {
        for(int x=0;x<=imageWidth;x++)
        {
            pixelRGB=image.getPixel(x,y);
            scalaGrigi=(pixelRGB.r*0.2126+pixelRGB.g*0.7152+pixelRGB.b*0.0722);
            intensita=scalaGrigi%atoi(argv[2]);

            writer << asciiConversion(intensita);
            //std::cout<<asciiConversion(intensita);
        }

        writer <<"\n";
        //std::cout<<"\n";
    }

    writer.close();
    std::cout<<"Densita: "<<atoi(argv[2])<<"\n";
    std::cout<<"Fatto!"<<"\n";


}
